



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android学习笔记：多个AsyncTask实例的并发问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android学习笔记：多个AsyncTask实例的并发问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 02:31:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>AsyncTask是Android给开发者提供的一个简单轻量级的多线程类，通过它我们可以很容易新建一个线程让在后台做一些耗时的操作（如IO操作、网络访问等），并在这个过程中更新UI。之所以说它轻量级，是因为不需要直接使用Handler、Thread等知识，使用起来比较简单，但也失去了一些灵活性，对于一些复杂的场景处理起来不方便。</p>
<p>如果一个APP进程中同时只创建和运行一个AsyncTask实例，则不会有任何问题。但如果在一个进程中如果有多个AsyncTask任务同时在执行，问题就比较复杂了。下面我们通过例子来看（我们例子是在Android 4中运行的）。</p>
<p><strong>一、测试1（默认多个Task是串行执行的）</strong></p>
<p>1、创建一个默认的app工程</p>
<p>2、创建一个类继承AsyncTask，代码如下</p>
<div>
<pre class="prettyprint linenums">package com.example.asynctaskdemo;

import android.os.AsyncTask;

public class MyAsyncTask extends AsyncTask&lt;String, Void, String&gt;{

	private String name;

	public MyAsyncTask(String name){<br />
		this.name = name;<br />
	}

	@Override<br />
	protected String doInBackground(String... params) {<br />
		System.out.println(name+" is run "+System.currentTimeMillis()+" thread id "+Thread.currentThread().getId());<br />
		try {<br />
			Thread.sleep(1000*10);<br />
		} catch (InterruptedException e) {<br />
			e.printStackTrace();<br />
		}<br />
		return null;<br />
	}

}
</pre>
</div>
<p>3、在Activity的onCreate方法中使用该Task，代码如下</p>
<div>
<pre class="prettyprint linenums">@Override<br />
	protected void onCreate(Bundle savedInstanceState) {<br />
		super.onCreate(savedInstanceState);<br />
		setContentView(R.layout.activity_main);

		for(int i=1;i&lt;5;i++){<br />
			MyAsyncTask task = new MyAsyncTask("task"+i);<br />
			task.execute(new String[0]);<br />
		}<br />
	}
</pre>
</div>
<p>　　我们在调试窗口，观察MyAsyncTask打印信息的间隔和顺序。发现这创建的4个任务是串行执行的，并不是并发的。</p>
<p>研究了AsyncTask的实现细节，在创建一个AsyncTask并通过其execute方法启动执行时，AsyncTask并不是创建一个独立的线程去执行。AsyncTask是通过线程池来管理和调度进程中的所有Task的。</p>
<p><strong>在&nbsp;Android2.3以前的版本（SDK/API 大于等于10的版本）</strong></p>
<p>多个AsyncTask任务是并发执行的，也就是说如果启动多个task，则会并发执行。但并发执行的数量取决于AsyncTask内部的线程池限制数量。如果超过了这个限额，新的任务只能等待。</p>
<p><strong>&nbsp;在Android 3.0及以后版本（SDK/API 大于等于11的版本）</strong></p>
<p>Google从Android 3.0开始对AsyncTask的调度执行做出了一些变化，对于execute提交的任务，按先后顺序每次只运行一个。也就是说它是按提交的次序，每次只启动一个线程执行一个任务，完成之后再执行第二个任务，也就是相当于只有一个后台线程在执行所提交的任务。上面的例子就验证了这一点。</p>
<p><strong>二、让AsyncTask并发执行</strong></p>
<p>因为默认情况下多个task是串行的，那怎么样让并发执行呢？AsyncTask增加了一个新的接口executeOnExecutor，这个接口允许开发者提供自定义的线程池来运行和调度Thread。我们把上面代码改下：</p>
<div>
<pre class="prettyprint linenums">@Override<br />
	protected void onCreate(Bundle savedInstanceState) {<br />
		super.onCreate(savedInstanceState);<br />
		setContentView(R.layout.activity_main);<br />
		for(int i=1;i&lt;11;i++){<br />
			MyAsyncTask task = new MyAsyncTask("task"+i);<br />
			//task.execute(new String[0]);<br />
			task.executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, new String[0]);<br />
		}<br />
	}
</pre>
</div>
<p>　　这里我们使用了executeOnExecutor方法代替了execute方法。并且executeOnExecutor方法的第一个参数是一个预定义的线程池。这时这几个task就可以并发执行了。这时我们观察打印的结果，发现有5个任务并发执行，可以看出有5个不同的线程号，查看AsyncTask的源码，发现并发线程数跟设备的cpu数量是有关的，因此不同的设备上可能看到的结果不完全一致，这点需要注意。只有前面的5个任务执行完后，才会执行后面的，并且通过打印的线程号可以看出，后面执行的任务是重用原来的线程，并没有创建新的线程，这就是线程池的作用。</p>
<p>我们再来改下代码，使用Android提供的另外一个预定义的线程池。代码如下：</p>
<div>
<pre class="prettyprint linenums">@Override<br />
	protected void onCreate(Bundle savedInstanceState) {<br />
		super.onCreate(savedInstanceState);<br />
		setContentView(R.layout.activity_main);<br />
		for(int i=1;i&lt;11;i++){<br />
			MyAsyncTask task = new MyAsyncTask("task"+i);<br />
			//task.execute(new String[0]);<br />
			task.executeOnExecutor(AsyncTask.SERIAL_EXECUTOR, new String[0]);<br />
		}<br />
	}
</pre>
</div>
<p>观察打印信息我们可以发现，这和调用execute方法一样，每个任务都是串行执行的。并且这个过程中最多创建了5个新的线程。</p>
<p><strong>三、自定义线程池</strong></p>
<p>我们可以利用java.util.concurrent.Executors中的各种静态方法创建供AsyncTask执行的线程池 ，可以指定线程的数量和调度的方式。其方法很多，我们这里介绍其中两种较为常用的。</p>
<p>1、让每个AsyncTask任务都单独起一个线程执行，也就是说所有的都是并发的。代码如：</p>
<div>
<pre class="prettyprint linenums">@Override<br />
	protected void onCreate(Bundle savedInstanceState) {<br />
		super.onCreate(savedInstanceState);<br />
		setContentView(R.layout.activity_main);<br />
		ExecutorService newCachedThreadPool = Executors.newCachedThreadPool();<br />
		for(int i=1;i&lt;11;i++){<br />
			MyAsyncTask task = new MyAsyncTask("task"+i);<br />
			task.executeOnExecutor(newCachedThreadPool, new String[0]);<br />
		}<br />
	}
</pre>
</div>
<p>　　通过观察打印可以看出，这多个任务都是并发执行的。</p>
<p>2、创建指定线程数量的线程池，并发数上限就是指定的线程数。但新任务产生，没有空闲的线程，就只能等待。代码如：</p>
<div>
<pre class="prettyprint linenums">@Override<br />
	protected void onCreate(Bundle savedInstanceState) {<br />
		super.onCreate(savedInstanceState);<br />
		setContentView(R.layout.activity_main);<br />
		ExecutorService newFixedThreadPool = Executors.newFixedThreadPool(3);<br />
		for(int i=1;i&lt;11;i++){<br />
			MyAsyncTask task = new MyAsyncTask("task"+i);<br />
			task.executeOnExecutor(newFixedThreadPool, new String[0]);<br />
		}<br />
	}
</pre>
</div>
<p>　　通过观察可以看出，有3个线程在并发执行。</p>
<p>总结下，从上面的例子中可以看出，如果一个进程中存在多个TASK需要并发执行的情况，那就需要用到AsyncTask一些更深的知识，需要考虑的问题更多。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8km0or9.html">Java开发环境搭建&mdash;&mdash;Eclipse配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7l6nx8.html">lower函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql52m08.html">javascript实现列表的点击展开折叠</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mx4629.html">BZOJ 1408&colon; &lbrack;Noi2002&rsqb;Robot</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ggy39.html">redhat centos yum源的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvdd21q.html">C&num;&lbrack;Serializable&rsqb;在C&num;中的作用-NET 中的对象序列化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oklkvx9.html">jsp 获取表单值&comma; 提交类型为multipart&sol;form-data处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wlw43q.html">Mosquitto-MQTT</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp05n39.html">asp&period;net core&plus;ef core</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ypw1z8.html">获取Storyboard中的视图控制器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpz0lxq.html">List&amp;lt&semi;T&amp;gt&semi;对元素的查找。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z6rwe9.html">Centos6&period;4三种更改hostname的方法之间的对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkmre08.html">Ubuntu12&period;04下Django1&period;4的删除目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k32n49.html">ZooKeeper连接并创建节点以及实现分布式锁操作节点排序输出最小节点Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pvdvv8.html">【Linux】Ubuntu安装Mysql 8&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506j668.html">mongoDB 数据库简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1p3p2q.html">微信小程序传递参数&lpar;字符串、数组、对象&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwnw178.html">C&num;  Winform 中DataGridView  实现单元格输入下拉框功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1zdgw9.html">java 下载网络文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g342vq.html">百度智能手环方案开源&lpar;含源码，原理图，APP，通信协议等&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlmzzk19.html">Spring Boot使用自定义的properties</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zgyl59.html">php：根据中文裁减字符串函数方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge1eje8.html">Android JNI入门第二篇&mdash;&mdash;Java参数类型与本地参数类型对照</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m7me48.html">Memory Architecture-SGA-Database Buffer Cache</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eye45x9.html">转换DataSet中的多个表为Excel中的多个Sheets</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjkvxz8.html">学习MVC遇到的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkwdg08.html">&lbrack;翻译&rsqb;Orchard-修改首页布局</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzjm5l8.html">stack smashing detect错误修正</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zogv2xq.html">在myeclipse中修改svn帐户</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge14de8.html">第2章 Python基础语法--Hello python</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
